unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DSPack, ActiveX, DirectShow9;

type
  TForm1 = class(TForm)
    FilterGraph1: TFilterGraph;
    VideoWindow1: TVideoWindow;
    Label1: TLabel;
    edtURL: TEdit;
    btnPlay: TButton;
    procedure btnPlayClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FASFReader: IBaseFilter;
    FAudioRender: IBaseFilter;
    procedure stopVideo;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
   self.Caption := Application.Title;
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   stopVideo();
end;

procedure TForm1.stopVideo;
begin
   FilterGraph1.Stop;
   FilterGraph1.Active := false;
   FilterGraph1.ClearGraph;
   if Assigned(FASFReader) then FASFReader := nil;
   if Assigned(FAudioRender) then FAudioRender := nil;
end;

procedure TForm1.btnPlayClick(Sender: TObject);
var
   LFileSource: IFileSourceFilter;
   //videoWindow: IVideoWindow;
   sUrl: WideString;
begin
   stopVideo();
   
   FilterGraph1.Active := True;
   FilterGraph1.ClearGraph;

   // video source
   CoCreateInstance(CLSID_WMAsfReader, nil, CLSCTX_INPROC, IBaseFilter, FASFReader);
   (FilterGraph1 As IGraphBuilder).AddFilter(FASFReader, 'WMASFReader');

   // audio renderer
   CoCreateInstance(CLSID_DSoundRender, nil, CLSCTX_INPROC, IBaseFilter, FAudioRender);
   (FilterGraph1 As IGraphBuilder).AddFilter(FAudioRender, 'Default Audio Render');

   sUrl := edtUrl.Text;
   if (FASFReader.QueryInterface(IID_IFileSourceFilter, LFileSource) = S_OK) then
      LFileSource.Load(PWideChar(sUrl), nil);

   //videoWindow := (VideoWindow1 as IVideoWindow);

   (FilterGraph1 as ICaptureGraphBuilder2).RenderStream(nil, @MEDIATYPE_Video, FASFReader, nil,
      //(videoWindow as IBaseFilter) );
      ((videoWindow1 As IVideoWindow) As IBaseFilter) );

   (FilterGraph1 as ICaptureGraphBuilder2).RenderStream(nil, @MEDIATYPE_Audio, FASFReader, nil,
      FAudioRender as IBaseFilter);
      //(videoWindow as IBaseFilter) );
      //((videoWindow1 As IVideoWindow) As IBaseFilter) );
      //nil);

   FilterGraph1.Play;

   //videoWindow := nil;
end;



end.
